unit fMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, atScript, atScripter, IDEMain, IDEDialog,
  Vcl.StdCtrls, InspectorControls, ComponentInspector, PropertyList, Vcl.ScriptForm,
  fIDEEditor, fObjectInspector, PropertyInspEditors, ScrMemo;


type
  TMyScriptForm = class(TScriptForm)
  private
    FCustomProps: TStrings;
    procedure SetCustomProps(const Value: TStrings);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property CustomProps: TStrings read FCustomProps write SetCustomProps;
  end;

  TfrmMain = class(TForm)
    IDEDialog: TIDEDialog;
    IDEEngine: TIDEEngine;
    IDEScripter: TIDEScripter;
    btnOpenIDE: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnOpenIDEClick(Sender: TObject);
  public
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

{ TfrmMain }

procedure TfrmMain.btnOpenIDEClick(Sender: TObject);
begin
  IDEDialog.Execute;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  IDEScripter.ScriptFormClass := TMyScriptForm;
end;

{ TMyScriptForm }

constructor TMyScriptForm.Create(AOwner: TComponent);
begin
  inherited;
  FCustomProps := TStringList.Create;
end;

destructor TMyScriptForm.Destroy;
begin
  FCustomProps.Free;
  inherited;
end;

procedure TMyScriptForm.SetCustomProps(const Value: TStrings);
begin
  FCustomProps.Assign(Value);
end;

end.
